!    ==========================================================
Program Heinrich1
  !  ==========================================================
  implicit none
  include 'heinrich1.h' 
  integer iocn_seaice,icoupling_period,i_nl

 
  call open_files 


  !  ---------------------------
  !  step coupled model in time:
  !  ---------------------------
!do i_nl=1,3
  call get_parameters
! write (*,*) i_nl,lat_glr(1)

  do icoupling_period = 1,ncoupling_periods
   
     call air_sea_fluxes
     ! step atmospheric model for one coupling_period
     call atmosphere
     ! step ocean and seaice for one coupling_period
     do iocn_seaice=1,ocn_seaice_steps_per_coupling
        ! step ocean one time step:
        call sea_ice       
        ! step landice one time step:
        call land_ice
        ! step seaice one time step:
        call ocean
     end do

     if (int((icoupling_period*coupling_period)/(1000*year))*(1000*year).eq.&
                icoupling_period*coupling_period) then

         write(*,*) 'years:',ntime_steps_atm*dt_atm/year,speeding_parameter

     end if     
!  end do
end do
  call write_restart
  stop
end Program Heinrich1


subroutine open_files
  implicit none
  include 'heinrich1.h'
!  integer(4) i4,system
!  i4=system("rm -rf Output/*")
  open(15,file='heinrich1.data')
  open(16,file='Output/output.heinrich')
  open(18,file='Output/transp.dat')
  open(19,file='Output/hight.dat')
!  open(29,file='Output/hight_too.dat')
  open(20,file='Output/seaice.dat')
  open(36,file='Output/restart',form='unformatted')
  open(22,file='Output/testing.dat')
  open(23,file='Output/atmosphere.dat')
  open(33,file='Output/results.dat')
  return
end subroutine open_files


subroutine write_restart
  implicit none
  integer n,i,m
  include 'heinrich1.h'

  if (write_restart_data) then
     rewind(36)
     !        write restart data for ocean model:
     write(36) " T:"
     write(36) (((T(n,i,m),n=1,3),i=1,nboxes_ocn),m=1,2)
     write(36) " air_to_sea_flux (H, watts/m^2):"
     write(36) (air_to_sea_flux(i,1),i=1,nsurface_boxes_ocn)
     write(36) " air_to_sea_flux (E-P, m/year):"
     write(36) (air_to_sea_flux(i,2)*year,i=1,nsurface_boxes_ocn)
     write(36) " transports (Sv):"
     write(36) u_thermohaline
     write(36) " atmospheric temperature:"
     write(36) ((T_atm(n,i),n=1,3),i=1,nboxes_atm)
     write(36) " atmospheric meridional fluxes:"
     write(36) f12_heat, f12_water
     write(36) " sea ice volume:"
     write(36) V_seaice
     write(36) " sea ice fraction:"
     write(36) frac_seaice
     write(36) " ocean_to_seaice_flux:"
     write(36) ocean_to_seaice_flux
     write(36) " shortwave_to_seaice_heat_flux:"
     write(36) shortwave_to_seaice_heat_flux
     write(36) "T_land_ice:"
     write(36) (((T_land_ice(n,i,m),n=1,3),i=1,NZ),m=1,nglacier)
     write(36) "land ice Hight:"
     write(36) ((H(n,m),n=1,3),m=1,nglacier)
     write(36) "Glacial stage:"
     write(36) (stage(m),m=1,nglacier)
     write(36) "land to sea flux:"
     write(36) (((land_to_sea_flux(n,i,m),n=1,nsurface_boxes_ocn),i=1,2),m=1,nglacier)
     write(36) "accumulation"
     write(36) (Acc(m),m=1,nglacier)
    
  end if
  return
end subroutine write_restart


subroutine get_parameters
  implicit none
  include 'heinrich1.h'
  integer n,i,m
  open(15,file='heinrich1.data')         !y
  read(15,nl_coupled)
  read(15,nl_ocn)
  read(15,nl_atm)
  read(15,nl_seaice)
  read(15,nl_landice)
  close(15)
  coupling_period=speeding_parameter*coupling_period
  dt_atm_box=speeding_parameter*dt_atm_box
  dt_ocn=speeding_parameter*dt_ocn
  dt_seaice=speeding_parameter*dt_seaice
  dt_land_ice=speeding_parameter*dt_land_ice

  !     Initialize boxes dimentions:
  !     ---------------------------- 
  D_ocn(1)=DepthUpper_ocn
  D_ocn(2)=DepthUpper_ocn
  D_ocn(3)=DepthLower_ocn
  D_ocn(4)=DepthLower_ocn

  L_ocn(1)=LengthSouth_ocn
  L_ocn(2)=LengthNorth_ocn
  L_ocn(3)=LengthNorth_ocn
  L_ocn(4)=LengthSouth_ocn

  W_ocn(1)=Width_ocn
  W_ocn(2)=Width_ocn
  W_ocn(3)=Width_ocn
  W_ocn(4)=Width_ocn

  L_atm(1)=LengthSouth_ocn
  L_atm(2)=LengthNorth_ocn
  W_atm(1) = W_ocn(1)/(1-frac_land(1))
  W_atm(2) = W_ocn(2)/(1-frac_land(2))

  !  Ocean box volumes:
  V_ocn(1:nboxes_ocn)=L_ocn(1:nboxes_ocn)*D_ocn(1:nboxes_ocn)*W_ocn(1:nboxes_ocn)

  !  area of boxes:
  A_ocn(1:nboxes_ocn)=L_ocn(1:nboxes_ocn)*W_ocn(1:nboxes_ocn)
  A_atm(1:nboxes_atm)=L_atm(1:nboxes_atm)*W_atm(1:nboxes_atm)

  !-----------------------
  !  Initial Conditions   
  !-----------------------

  !  (T,S) initial conditions for the ocean:
  T(1:3,1,1)= 20.0
  T(1:3,2,1)= 1.0
  T(1:3,3,1)= 1.0
  T(1:3,4,1)= 1.0
  T(1:3,1,2)= 36.0
  T(1:3,2,2)= 34.5
  T(1:3,3,2)= 34.5
  T(1:3,4,2)= 34.5

  !  Temperature initial conditions for atm (at 500mb):
  T_atm(1:3,1)= 27.0+273.0
  T_atm(1:3,2)= -5.0+273.0

  ! input of land ice temperature into two first times:
   H(:,1)=1000.0
!  H(:,2)=1500.0
!   H(:,3)=1666.0 
!   H(:,4)=2000.0
   lat_par(:)=(lat_glr(:)-30.0)/(75.0-lat_glr(:))
   T_land_ice(1:3,1:NZ,1)=((lat_par(1)*T_atm(3,2)+T_atm(3,1))/(lat_par(1)+1)-273.0)-lapse_rate*(H(1,1)) 
!   T_land_ice(1:3,1:NZ,2)=((lat_par(2)*T_atm(3,2)+T_atm(3,1))/(lat_par(2)+1)-273.0)-lapse_rate*(H(1,2)) 
!   T_land_ice(1:3,1:NZ,3)=((lat_par(3)*T_atm(3,2)+T_atm(3,1))/(lat_par(3)+1)-273.0)-lapse_rate*(H(1,3))
!   T_land_ice(1:3,1:NZ,4)=((lat_par(4)*T_atm(3,2)+T_atm(3,1))/(lat_par(4)+1)-273.0)-lapse_rate*(H(1,4))  
   stage(:)=0
 
  !  initial fluxes for the ocean:
  air_to_sea_flux(1:nsurface_boxes_ocn,1:ntracers_ocn)=0.0

  ! initial conditions for seaice:
  V_seaice(:,:) = 0.0
  frac_seaice(:) = 0.0
  ocean_to_seaice_flux(:,:) = 0.0
  shortwave_to_seaice_heat_flux(:) = 0.0
  thickness_seaice(:)=seaice_growth_thickness

  ! initialize time step counters:
  ntime_steps_ocn=0.0
  ntime_steps_atm=0.0
  ntime_steps_seaice=0.0
  ntime_steps_landice=0.0

 ! set atmospheric model time step:
   dt_atm=dt_atm_box

 ! Calculate number of time steps per coupling period:
  ncoupling_periods=(tend-tbegin)/coupling_period+1
  atm_steps_per_coupling_period=coupling_period/dt_atm
  ocn_seaice_steps_per_coupling=coupling_period/dt_ocn

  if (read_restart_data) then
     !        Read restart data:
     read(36) ! " T:"
     read(36) (((T(n,i,m),n=1,3),i=1,nboxes_ocn),m=1,2)
     read(36) ! " air_to_sea_flux (H, watts/m^2):"
     read(36) (air_to_sea_flux(i,1),i=1,nsurface_boxes_ocn)
     read(36) ! " air_to_sea_flux (E-P, cm/sec):"
     read(36) (air_to_sea_flux(i,2),i=1,nsurface_boxes_ocn)
     read(36) ! " transports (Sv):"
     read(36) u_thermohaline
     read(36) ! " atmospheric temperature:"
     read(36) ((T_atm(n,i),n=1,3),i=1,nboxes_atm)
     read(36) ! " atmospheric meridional fluxes:"
     read(36) f12_heat, f12_water
     read(36) ! " sea ice volume:"
     read(36) V_seaice
     read(36) ! " sea ice fraction:"
     read(36) frac_seaice
     read(36) ! " ocean_to_seaice_flux:"
     read(36) ocean_to_seaice_flux
     read(36) ! " shortwave_to_seaice_heat_flux:"
     read(36) shortwave_to_seaice_heat_flux
     read(36) ! "T_land_ice:"
     read(36) (((T_land_ice(n,i,m),n=1,3),i=1,NZ),m=1,nglacier)
     read(36) ! "land ice Hight:"
     read(36) ((H(n,m),n=1,3),m=1,nglacier)
     read(36) ! "Glacial stage:"
     read(36) (stage(m),m=1,nglacier)
     read(36) !"land to sea flux:"
     read(36) (((land_to_sea_flux(n,i,m),n=1,nsurface_boxes_ocn),i=1,2),m=1,nglacier)
     read(36) !"accumulation"
     read(36) (Acc(m),m=1,nglacier)
    
  end if

  return
end subroutine get_parameters

subroutine ocean
  !  Do a ONE TIME STEP of 
  !  a 4-box thermohaline circulation model.
  !
  !       -------------     -----                 	}
  !       | 1         |---> | 2 |                 	} upper boxes
  !       -------------     -----                 	}
  !        ^                              
  !        |                  |           
  !        |                  |           
  !        |                  V           
  !       -------------     -----                 	}
  !       | 4         |     | 3 |                 	}
  !       |           |<--- |   |                 	}  deep boxes
  !       |           |     |   |                       }
  !       |           |     |   |                       }
  !       -------------     -----                 	}
  !       EQ                    NP

  implicit none
  include 'heinrich1.h'
  integer nt,i,m
  real*8 f12(1:ntracers_ocn),f23(1:ntracers_ocn),f34(1:ntracers_ocn),f41(1:ntracers_ocn)
  real*8 sigma,P_sigma,T_sigma,S_sigma
  real*8 rhoUpperNorth, rhoUpperSouth, rhoLowerNorth, rhoLowerSouth
  real*8 hdiff12(1:ntracers_ocn), hdiff34(1:ntracers_ocn) 
  real*8 vdiff14(1:ntracers_ocn), vdiff23(1:ntracers_ocn)
  real*8 T1_temp(1:ntracers_ocn), T2_temp(1:ntracers_ocn), T3_temp(1:ntracers_ocn),T4_temp(1:ntracers_ocn)
  real*8 A,A23,A14,B,tanh23,tanh14
  !     ==================================
  !     Step ocean model ONE STEP in time:
  !     ==================================
  do nt=ntime_steps_ocn+1,ntime_steps_ocn+1

     !        Time since begining of model run:
     time=dt_ocn*(nt-1)

    



     !        ---------
     !        Calc rho:
     !        ---------

        do i=1,nboxes_ocn
           P_sigma=0.0
           T_sigma=T(2,i,1)
           S_sigma=T(2,i,2)
           rho(i)=sigma(P_sigma,T_sigma,S_sigma)
        end do
 
     !        -----------------------------------
     !        Calc mass transports between boxes:
     !        -----------------------------------

     rhoUpperSouth=rho(1)
     rhoUpperNorth=rho(2)
     rhoLowerNorth=rho(3)
     rhoLowerSouth=rho(4)

     !        -----------------------------------------------------------------
     !        Convect using Implicit solution and a hyperbolic-tangent profile:
     !        -----------------------------------------------------------------

    A=(2.78E9/2)*2*dt_ocn   !(Time scale of 10 weeks for V_ocn(2))
    B=50 
    A23=A*((1/V_ocn(2)+1/V_ocn(3)))
    A14=A*((1/V_ocn(1)+1/V_ocn(4)))  
    tanh23=tanh(B*(rho(2)-rho(3)))+1
    tanh14=tanh(B*(rho(1)-rho(4)))+1                                                                         
                                                                          
    T1_temp(1:ntracers_ocn)=T(2,1,1:ntracers_ocn)                                        
    T2_temp(1:ntracers_ocn)=T(2,2,1:ntracers_ocn)                                        
    T3_temp(1:ntracers_ocn)=T(2,3,1:ntracers_ocn)                                        
    T4_temp(1:ntracers_ocn)=T(2,4,1:ntracers_ocn) 

   ! Converction Northern boxes: 
    T(2,2,1:ntracers_ocn)=(1+A*tanh23/V_ocn(3))/(1+A23*tanh23)*T2_temp(1:ntracers_ocn) &
                            +A*tanh23/V_ocn(2)/(1+A23*tanh23)*T3_temp(1:ntracers_ocn)
    T(2,3,1:ntracers_ocn)=(1+A*tanh23/V_ocn(2))/(1+A23*tanh23)*T3_temp(1:ntracers_ocn) &
                            +A*tanh23/V_ocn(3)/(1+A23*tanh23)*T2_temp(1:ntracers_ocn)
   ! Convection Southern boxes: 
    T(2,1,1:ntracers_ocn)=(1+A*tanh14/V_ocn(4))/(1+A14*tanh14)*T1_temp(1:ntracers_ocn) &
                            +A*tanh14/V_ocn(1)/(1+A14*tanh14)*T4_temp(1:ntracers_ocn)
    T(2,4,1:ntracers_ocn)=(1+A*tanh14/V_ocn(1))/(1+A14*tanh14)*T4_temp(1:ntracers_ocn) &
                            +A*tanh14/V_ocn(4)/(1+A14*tanh14)*T1_temp(1:ntracers_ocn)
 
   ! Recalculate density:

           do i=1,nboxes_ocn
              P_sigma=0.0
              T_sigma=T(2,i,1)
              S_sigma=T(2,i,2)
              rho(i)=sigma(P_sigma,T_sigma,S_sigma)
           end do
 
        rhoUpperSouth=rho(1)
        rhoUpperNorth=rho(2)
        rhoLowerNorth=rho(3)
        rhoLowerSouth=rho(4)
        
     u_thermohaline=C_u*g*0.25*( &                                 !y
         DepthUpper_ocn*(rhoUpperNorth-rhoUpperSouth)+ &
          DepthLower_ocn*(rhoLowerNorth-rhoLowerSouth)) 
    
    if (no_reversed_THC ) then              !y
       if (u_thermohaline .lt. 6*Sv) then 
         u_thermohaline=6*Sv
       end if
    end if

     ! calculate mass fluxes that go into the advection of T,S:
       u12=u_thermohaline
       u23=u_thermohaline
       u34=u_thermohaline
       u41=u_thermohaline

     !        -----------------------------------
     !        Calc heat/salt transports between boxes:
     !        -----------------------------------

     if (u12.ge.0.0) then
        f12(1:ntracers_ocn)=u12*T(2,1,1:ntracers_ocn)*[rho_0*Cp_ocn, 1.0]
     else
        f12(1:ntracers_ocn)=u12*T(2,2,1:ntracers_ocn)*[rho_0*Cp_ocn, 1.0]
     end if
     if (u23.ge.0.0) then
        f23(1:ntracers_ocn)=u23*T(2,2,1:ntracers_ocn)*[rho_0*Cp_ocn, 1.0]
     else
        f23(1:ntracers_ocn)=u23*T(2,3,1:ntracers_ocn)*[rho_0*Cp_ocn, 1.0]
     end if
     if (u34.ge.0.0) then
        f34(1:ntracers_ocn)=u34*T(2,3,1:ntracers_ocn)*[rho_0*Cp_ocn, 1.0]
     else
        f34(1:ntracers_ocn)=u34*T(2,4,1:ntracers_ocn)*[rho_0*Cp_ocn, 1.0]
     end if
     if (u41.ge.0.0) then
        f41(1:ntracers_ocn)=u41*T(2,4,1:ntracers_ocn)*[rho_0*Cp_ocn, 1.0]
     else
        f41(1:ntracers_ocn)=u41*T(2,1,1:ntracers_ocn)*[rho_0*Cp_ocn, 1.0]
     end if

     hdiff12(1:ntracers_ocn)=kappa_H_srfc *(T(1,1,1:ntracers_ocn)-T(1,2,1:ntracers_ocn)) & 
          *(Width_ocn*DepthUpper_ocn) *[rho_0*Cp_ocn, 1.0]/(0.5*(L_ocn(1)+L_ocn(2)))
     hdiff34(1:ntracers_ocn)=kappa_H_deep *(T(1,3,1:ntracers_ocn)-T(1,4,1:ntracers_ocn)) & 
          *(Width_ocn*DepthLower_ocn) *[rho_0*Cp_ocn, 1.0]/(0.5*(L_ocn(3)+L_ocn(4)))
     vdiff14(1:ntracers_ocn)=kappa_V_south*(T(1,1,1:ntracers_ocn)-T(1,4,1:ntracers_ocn)) & 
          *(Width_ocn*LengthSouth_ocn)*[rho_0*Cp_ocn, 1.0]/(0.5*(D_ocn(1)+D_ocn(4)))
     vdiff23(1:ntracers_ocn)=kappa_V_north*(T(1,2,1:ntracers_ocn)-T(1,3,1:ntracers_ocn)) & 
          *(Width_ocn*LengthNorth_ocn)*[rho_0*Cp_ocn, 1.0]/(0.5*(D_ocn(2)+D_ocn(3)))


     !   ---------
     !   step T,S:
     !   ---------
     T(3,1,1:ntracers_ocn)=T(1,1,1:ntracers_ocn)+2.*dt_ocn*( &
          -f12(1:ntracers_ocn) &
          +f41(1:ntracers_ocn) &
          +air_to_sea_flux(1,1:ntracers_ocn)*[1.0,-S0]*A_ocn(1) &
          -ocean_to_seaice_flux(1,1:ntracers_ocn)*[1.0,-S0]*A_ocn(1) &
          -vdiff14(1:ntracers_ocn) &
          -hdiff12(1:ntracers_ocn) &
          )/(V_ocn(1)*[rho_0*Cp_ocn, 1.0])

     T(3,2,1:ntracers_ocn)=T(1,2,1:ntracers_ocn)+2.*dt_ocn*( &
          +f12(1:ntracers_ocn) &
          -f23(1:ntracers_ocn) &
          +air_to_sea_flux(2,1:ntracers_ocn)*[1.0,-S0]*A_ocn(2)-(                &       !y   
            (Acc(1)-Abl(1))*(rho_ice/rho_0)*[0.0,-S0]*area_land_ice(1)) +          &
!            (Acc(2)-Abl(2))*(rho_ice/rho_0)*[0.0,-S0]*area_land_ice(2))  +          &  
!            (Acc(3)-Abl(3))*(rho_ice/rho_0)*[0.0,-S0]*area_land_ice(3) +          &
!            (Acc(4)-Abl(4))*(rho_ice/rho_0)*[0.0,-S0]*area_land_ice(4))          &  
          +land_to_sea_flux(2,1:ntracers_ocn,1)*[0.0,-S0]                        &
!          +land_to_sea_flux(2,1:ntracers_ocn,2)*[0.0,-S0]                        &  
!          +land_to_sea_flux(2,1:ntracers_ocn,3)*[0.0,-S0]                        &
!          +land_to_sea_flux(2,1:ntracers_ocn,4)*[0.0,-S0]                        &  
          -ocean_to_seaice_flux(2,1:ntracers_ocn)*[1.0,-S0]*A_ocn(2)             &
          -vdiff23(1:ntracers_ocn) &
          +hdiff12(1:ntracers_ocn) &
          )/(V_ocn(2)*[rho_0*Cp_ocn, 1.0])

     T(3,3,1:ntracers_ocn)=T(1,3,1:ntracers_ocn)+2.*dt_ocn*( &
          +f23(1:ntracers_ocn) &
          -f34(1:ntracers_ocn) &
          +vdiff23(1:ntracers_ocn) &
          -hdiff34(1:ntracers_ocn) &
          )/(V_ocn(3)*[rho_0*Cp_ocn, 1.0])

     T(3,4,1:ntracers_ocn)=T(1,4,1:ntracers_ocn)+2.*dt_ocn*( &
          +f34(1:ntracers_ocn) &
          -f41(1:ntracers_ocn) &
          +vdiff14(1:ntracers_ocn) &
          +hdiff34(1:ntracers_ocn) &
          )/(V_ocn(4)*[rho_0*Cp_ocn, 1.0])

   
     !   ---------------------------
     !   Prepare for next time step:
     !   ---------------------------
     ! Robert filter:
     T(2,1:nboxes_ocn,1:ntracers_ocn) = T(2,1:nboxes_ocn,1:ntracers_ocn) &
          + robert_filter_coeff * &
          (   T(3,1:nboxes_ocn,1:ntracers_ocn) &
          - 2*T(2,1:nboxes_ocn,1:ntracers_ocn) &
          +   T(1,1:nboxes_ocn,1:ntracers_ocn) &
          )
    !  normal time step:
     T(1,1:nboxes_ocn,1:ntracers_ocn)=T(2,1:nboxes_ocn,1:ntracers_ocn)
     T(2,1:nboxes_ocn,1:ntracers_ocn)=T(3,1:nboxes_ocn,1:ntracers_ocn)

  end do
  ntime_steps_ocn=ntime_steps_ocn+1

  if  (int(time/tprint)*tprint.eq.time) then

     write(18,'(14g14.6)')time/(3600.*24.*365.),u_thermohaline/Sv,T(2,1,1),T(2,2,1),T(2,3,1),             &
                          T(2,4,1),T(2,1,2),T(2,2,2),T(2,3,2),T(2,4,2),rho(1),rho(2),rho(3),rho(4)  
                  
  end if
   
  return
end subroutine ocean


subroutine calc_FW_flux
  ! calculate meridional fresh water flux (f12_water)
  implicit none
  include 'heinrich1.h'
  real*8 Temperature_CC, A_CC, B_CC, RH_CC, Ps_CC, epsilon_CC 
  real*8 qsat_CC, q_CC, dq_dT_CC, dT_dy, dT_dy_CC, dq_dy, q1, q2

     A_CC=2.53d+11                                ! Pascall
     B_CC=5.42d+3                                 ! K
     RH_CC=0.7                                    ! relative humidity
     Ps_CC=1.0d+5                                 ! surface pressure, pascal
     epsilon_CC=0.622
    
! Stone's water flux parameterization:
!     q1=RH_CC*A_CC*epsilon_CC*exp(-B_CC/T_atm(2,1))/Ps_CC
!     q2=RH_CC*A_CC*epsilon_CC*exp(-B_CC/T_atm(2,2))/Ps_CC
!     dT_dy=(T_atm(2,2)-T_atm(2,1))/(0.5*(L_atm(1)+L_atm(2)))
!     dq_dy=(q2-q1)/(0.5*(L_atm(1)+L_atm(2)))
!     f12_water = -K_water_atm_marotzke*abs(dT_dy)**2*dq_dy

! Hezi's water flux parameterization:
!     qsat_CC=A_CC*exp(-B_CC/T_atm(2,2))  ! NORTHERN BOX atmc humidity
!     q_CC=RH_CC*epsilon_CC*qsat_CC/Ps_CC
!     dT_dy_CC=(T_atm(2,2)-T_atm(2,1))/(0.5*(L_atm(1)+L_atm(2)))
!     f12_water = -K_water_atm_q_target*dT_dy_CC*qsat_CC

! dq_dy, and temperature for q_sat at the boundry
     Temperature_CC=T_atm(2,1)+(T_atm(2,2)-T_atm(2,1))*L_atm(1)/(L_atm(1)+L_atm(2))  !(linear)
     qsat_CC=A_CC*exp(-B_CC/Temperature_CC)
     q_CC=RH_CC*epsilon_CC*qsat_CC/Ps_CC
     dq_dT_CC=q_CC*(B_CC/Temperature_CC**2)
     dT_dy_CC=(T_atm(2,2)-T_atm(2,1))/(0.5*(L_atm(1)+L_atm(2)))
     dq_dy=dq_dT_CC*dT_dy_CC
     f12_water = -K_water_atm_dq_dy_bndry*dq_dy
end subroutine calc_FW_flux


subroutine air_sea_fluxes
  implicit none
  include 'heinrich1.h'

     ! air sea heat flux: (watts/m^2) (sensible)
     air_to_sea_flux(1:nsurface_boxes_ocn,1) = & 
       C_bulk_air_sea_heat_flux&
       * (T_atm(2,1:nboxes_atm)-273.0-T(2,1:nsurface_boxes_ocn,1)) &
       * ( (1-frac_seaice(1:nsurface_boxes_ocn)) &                        ! (open ocean part)
       + frac_seaice(1:nsurface_boxes_ocn)*0.05/(1.7+thickness_seaice(:)))! sea ice covered part

     ! air-sea fresh water flux: (m/sec)
     air_to_sea_flux(1:nsurface_boxes_ocn,2)=[-1.0, 1.0]*f12_water/A_ocn(1:nsurface_boxes_ocn)

end subroutine air_sea_fluxes


subroutine atmosphere
  !  A 2-box energy balance model.
  !
  !       -------------     -----  
  !       | 1         |<--->| 2 |  
  !       |           |     |   |  
  !       -------------     -----  
  !       EQ                 NP

  implicit none
  include 'heinrich1.h'
  integer nt,i
  real*8 ac1,R_gas_const,Ps_atm
  character*16 atm_printout_units

  !     =======================
  !     Step atm model in time:
  !     =======================
  do nt=ntime_steps_atm+1,ntime_steps_atm+atm_steps_per_coupling_period

     !        Time since begining of model run:
     time = dt_atm*(nt-1)

     !   ---------------------------------------------
     !   Calc heat/ moisture transports between boxes:
     !   ---------------------------------------------
     f12_heat(1) = (K_heat_atm*(T_atm(2,1)-T_atm(2,2))/(0.5*( L_atm(1)+L_atm(2))))
     f12_heat(2) = - f12_heat(1)

    call calc_FW_flux    

     albedo(:)= &
            albedo_clouds(:) &
          + (1-albedo_clouds(:)) &
          *     (  frac_land(:) * albedo_land(:) &
          +        (1-frac_land(:)) &
          *         (  frac_seaice(:)*albedo_seaice &
          +            (1-frac_seaice(:))*albedo_ocean &
          ))
     incoming_radiation(:)= &
          ! use total albedo to calculate radiation that remains in atmosphere:
          solar_incoming_radiation(:)*(1-albedo(:) ) &
          ! substract radiation that is absorbed by seaice:
          -frac_seaice(:)*shotrwave_penetration_to_seaice &
          *solar_incoming_radiation(:)*(1-albedo_clouds(:))*(1-frac_land(:))&!*frac_seaice(:) &
          *(1-albedo_seaice)

     longwave_outgoing(:) = sigma_SB*emissivity(:) &
          *T_atm(2,:)*T_atm(2,:)*T_atm(2,:)*T_atm(2,:)

     ! Gas constant for dry air (J/Kg*K)
     R_gas_const = 287.04
     ! surface pressure taken as 1000mb
     Ps_atm = 1.0d+5
     ! normalization factor from J/s into K/s:
     ac1=(2.**(R_gas_const/Cp_atm))*g/(Ps_atm*Cp_atm)     ! 2^(R/Cp)*g/(Ps*Cp)

     !     ---------
     !     step T:
     !     ---------
     T_atm(3,:)=T_atm(1,:)+2.*dt_atm*( &
          -f12_heat(:)/A_atm(:) &
          -air_to_sea_flux(:,1)*A_ocn(1:nsurface_boxes_ocn)/A_atm(:) &
          +incoming_radiation(:) &
          -longwave_outgoing(:) &
          )*ac1
 
     !    ---------------------------
     !    Prepare for next time step:
     !    ---------------------------
        ! Robert filter:
     T_atm(2,1:nboxes_atm) = T_atm(2,1:nboxes_atm) &
          + robert_filter_coeff * &
          (   T_atm(3,1:nboxes_atm) &
          - 2*T_atm(2,1:nboxes_atm) &
          +   T_atm(1,1:nboxes_atm) &
          )

     !  normal time step:
     T_atm(1,:)=T_atm(2,:)
     T_atm(2,:)=T_atm(3,:)

      if (print_atm_in_Pwatts) then
        convert_to_Pw(:)=A_atm(:)/1.e15
        atm_printout_units="Pwatts   "
        else
        convert_to_Pw(:)=1.0
        atm_printout_units="watts/m^2"
     end if

  end do
  ntime_steps_atm=ntime_steps_atm+atm_steps_per_coupling_period

end subroutine atmosphere


subroutine sea_ice
  !  Do a ONE TIME STEP of 
  !  a thermodynamic sea ice box model.
  implicit none
  include 'heinrich1.h'
  integer nt, ibox
  real*8 seaice_abl(1:nsurface_boxes_ocn)
  !     ==========================
  !     Step seaice model in time:
  !     ==========================
  do nt=ntime_steps_seaice+1,ntime_steps_seaice+1

     !        Time since begining of model run:
     time = dt_seaice*(nt-1)

   ! calculate contribution of short wave to melting of seaice:
     shortwave_to_seaice_heat_flux(:) = &
          frac_seaice(:)*shotrwave_penetration_to_seaice &
          *solar_incoming_radiation(:)*(1-albedo_clouds(:))*(1-frac_land(:)) &  !y
          *(1-albedo_seaice)
   ! calculate ablation of seaice if T_atm bigger than -10 C rate:(8mm/(day*C))

     if (T_atm(3,2)-273.0 .gt.10.0) then
         seaice_abl(:)=2.0E-7*frac_seaice(:)*((T_atm(3,:)-273.0+10))*Cp_ocn*rho_0
         else
         seaice_abl(:)=0.0
     end if

     do ibox=1,nsurface_boxes_ocn
        ! If ocean temperature is lower than freezing temperature, or if it 
        ! is higher but sea ice cover exists, then 
        if ( T(2,ibox,1) .lt. T_freezing  .or. &
             ( T(2,ibox,1).gt.T_freezing .and. frac_seaice(ibox) .gt. 0.0 )) then

           ! calculate heat needed to restore ocean to freezing temp, which 
           ! will also be used for freezing/melting:
           ocean_to_seaice_flux(ibox,1) = &
                -(1/seaice_restoring_time)*Cp_ocn*rho_0*D_ocn(ibox) &
                *(T_freezing-T(2,ibox,1))
        else
           ocean_to_seaice_flux(ibox,1) = 0.0
        end if
    
     end do

     !  ------------
     !  step seaice:
     !  ------------

     if (frac_seaice(2) .gt.0.0 .or. abs(ocean_to_seaice_flux(2,1)) .gt. 0.0) then
     
        V_seaice(3,:)=V_seaice(1,:) + 2.*dt_seaice*( &

          ! seaice growth due to heating/ cooling:
          (- ocean_to_seaice_flux(:,1) &
           -shortwave_to_seaice_heat_flux(:) & 
           -seaice_abl(:)  &
          )/(rho_ice*ice_fusion_heat) &

          ! seaice growth due to percipitation falling on sea ice:
          ! dbgz: need to make sure that precipitation falling on land goes 
          ! to ocean, not sea ice:
          + air_to_sea_flux(:,2)*frac_seaice(:)*(rho_0/rho_ice) &

          )*A_ocn(1:nsurface_boxes_ocn)
     end if
     
     ! if seaice volume is negative, we need to form seaice to 
     ! bring its volume to zero.  This means cooling the ocean, so that 
     ! ocean_to_seaice_flux is positive:
     do ibox=1,nsurface_boxes_ocn
        if (V_seaice(3,ibox).lt.0.0)          then
           ocean_to_seaice_flux(ibox,1)=ocean_to_seaice_flux(ibox,1) &
                - V_seaice(3,ibox)*(rho_ice*ice_fusion_heat)/(2.0*dt_seaice*A_ocn(ibox))
           V_seaice(3,ibox) = 0.0
           ocean_to_seaice_flux(ibox,2) = -(V_seaice(1,ibox)) &
           *(rho_ice/rho_0)/(2.0*dt_seaice*A_ocn(ibox))

        else if  (V_seaice(3,ibox).eq.0.0)    then 
           ocean_to_seaice_flux(ibox,2) = 0.0

        else
! fresh water flux from ocean to seaice due to melting/ freezing (m/sec):
          ocean_to_seaice_flux(ibox,2) = &
          (V_seaice(3,ibox)-V_seaice(1,ibox)) &
          *(rho_ice/rho_0)/(2.0*dt_seaice*A_ocn(ibox))

        end if
     end do

     if  (int(time/tprint)*tprint.eq.time) then
         write(20,'(8f18.6)') time/(3600.*24.*365.), frac_seaice(2),                              &
              - ocean_to_seaice_flux(2,1)*A_ocn(2)/(rho_ice*ice_fusion_heat),                     &
              - shortwave_to_seaice_heat_flux(2)*A_ocn(2)/(rho_ice*ice_fusion_heat), &
              -seaice_abl(2)*A_ocn(2)/(rho_ice*ice_fusion_heat),                     &
               air_to_sea_flux(2,2)*frac_seaice(2)*(rho_0/rho_ice)*A_ocn(2),                      &
!                   V_seaice(1,2), V_seaice(2,2),V_seaice(3,2),                          &
               air_to_sea_flux(2,2)*A_ocn(2),ocean_to_seaice_flux(2,2)*A_ocn(2)
     end if                      
     !    ---------------------------
     !    Prepare for next time step:
     !    ---------------------------

       ! Robert filter:
       V_seaice(2,1:nsurface_boxes_ocn) = V_seaice(2,1:nsurface_boxes_ocn) &
            + robert_filter_coeff * &
            (   V_seaice(3,1:nsurface_boxes_ocn) &
            - 2*V_seaice(2,1:nsurface_boxes_ocn) &
            +   V_seaice(1,1:nsurface_boxes_ocn))

     !  normal time step:
     V_seaice(1,:)=V_seaice(2,:)
     V_seaice(2,:)=V_seaice(3,:)

     ! calculate fraction of ocean box area covered by sea ice
     do ibox=1,nsurface_boxes_ocn
        if (V_seaice(3,ibox)/seaice_growth_thickness.lt.A_ocn(ibox)) then
           frac_seaice(ibox)=(V_seaice(3,ibox)/seaice_growth_thickness)/A_ocn(ibox)
           thickness_seaice(ibox)=seaice_growth_thickness
        else
           frac_seaice(ibox)=1.0
           thickness_seaice(ibox)=V_seaice(3,ibox)/A_ocn(ibox)
        end if
     end do 

  end do
  ntime_steps_seaice=ntime_steps_seaice+1

end subroutine sea_ice
 

subroutine land_ice 
     
implicit none
include 'heinrich1.h'
integer::   nt, j, i ,glr,k
real::    dz(1:nglacier), d_zeta ,zeta, abl_func(1:nglacier),abl_min=-10.0 ,T_top(1:nglacier) !y
real::    accumelation_stage=0, collapse_stage=1 




      do nt=ntime_steps_landice+1,ntime_steps_landice+1 
   
        do glr=1,nglacier

          time=(nt-1)*dt_land_ice
          T_top(glr)=((lat_par(glr)*T_atm(3,2)+T_atm(3,1))/(lat_par(glr)+1)-273.0)-lapse_rate*H(3,glr)

        if ( T_top(glr) > abl_min) then
            abl_func(glr)=((T_top(glr)-abl_min))   
          else
            abl_func(glr)=0.0
        end if  
       
          Abl(glr)=abl_rate*abl_func(glr)
          Acc(glr)=air_to_sea_flux(2,2)*acc_factor(glr)*(rho_0/rho_ice)*exp(-H(2,glr)/1000.0)           
   
          ! Hight of glacier equation:

          H(3,glr)=H(1,glr)+2*dt_land_ice*((Acc(glr)-Abl(glr))*(1-stage(glr))-(H(2,glr)/tau)*stage(glr))
       
          ! Robert filter for hight:
     
          H(2,glr)=H(2,glr)+robert_filter_coeff*(H(3,glr)-2*H(2,glr)+H(1,glr))
    
          ! dz(glr)=H(2,glr)/float(NZ)

          d_zeta=1/float(NZ)

          ! Boundry conditions
        !----------------------!
          if (stage(glr)==accumelation_stage) then

              T_land_ice(3,1,glr)=T_land_ice(1,1,glr)+2*dt_land_ice*(              &
                 
                  (ice_thermal_cond/(Cp_ice*rho_ice*d_zeta*H(1,glr)*H(1,glr)))*    &

                  (((T_land_ice(1,2,glr)-T_land_ice(1,1,glr))/d_zeta)+             &

                  (Geothermal_heat*H(1,glr))/ice_thermal_cond)+                    &
                                          
                  (1/H(2,glr))*(Acc(glr)-Abl(glr))*(1/float(NZ))*0.5*              &

                  ((T_land_ice(2,2,glr)-T_land_ice(2,1,glr))/(d_zeta)-             &

                  Geothermal_heat*H(2,glr)/ice_thermal_cond))

              T_land_ice(3,NZ,glr)=((lat_par(glr)*T_atm(3,2)+T_atm(3,1))/(lat_par(glr)+1)-273.0)-lapse_rate*H(3,glr)  !y

         end if

          if (stage(glr)==collapse_stage) then

              T_land_ice(3,1,glr)=0.0
    
              T_land_ice(3,NZ,glr)=((lat_par(glr)*T_atm(3,2)+T_atm(3,1))/(lat_par(glr)+1)-273.0)-lapse_rate*H(3,glr)  !y

              Acc(glr)=0
              Abl(glr)=0
          end if

         ! do k=1,3   keep upper boundery under -2
              if (T_land_ice(3,NZ,glr) .gt. -2.0) then           !y
                  T_land_ice(3,NZ,glr)= -2.0                !y
              end if
          !  end do

            
          ! set temperatures in glacier vector:
          !------------------------------------!
          do i=2,NZ-1 

              zeta=i/float(NZ)
      
              ! Temperature equation:

               T_land_ice(3,i,glr)=T_land_ice(1,i,glr)+2*dt_land_ice*(                                    &
                             
                   (ice_thermal_cond/(Cp_ice*rho_ice*d_zeta*d_zeta*H(1,glr)*H(1,glr)))*                   &

                   (T_land_ice(1,i+1,glr)-2*T_land_ice(1,i,glr)+T_land_ice(1,i-1,glr))+                   &
                     
                   (1-stage(glr))*(Acc(glr)-Abl(glr))*zeta*(T_land_ice(2,i+1,glr)-T_land_ice(2,i-1,glr))/ &
                      
                   (2*d_zeta*H(2,glr)) +                                                                  &
  
                   stage(glr)*(T_land_ice(2,i+1,glr)-T_land_ice(2,i-1,glr))*zeta/(2*d_zeta*tau))

               ! Robert filter for temperature:

               T_land_ice(2,i-1,glr)=T_land_ice(2,i-1,glr)+robert_filter_coeff*           &
                        
                         (T_land_ice(3,i-1,glr)-2*T_land_ice(2,i-1,glr)+T_land_ice(1,i-1,glr))
 
   
          end do  


            do k=1,3
              if (T_land_ice(k,NZ,glr) .gt. -2.0) then           !y
                   T_land_ice(k,NZ,glr)=-2.0                !y
              end if
            end do
     
          ! Condition - Accumelation or collapse?

          if (stage(glr)==accumelation_stage) then

              if (T_land_ice(3,1,glr)>=0 ) then

                  stage(glr)=collapse_stage 

!                if (time/year .gt. 50000.0 ) then
!                  write(29,'(14g14.6)') time/year,H(3,1),H(3,2)
!                end  if

              end if
         
          else
              if (abs(T_land_ice(3,3,glr)-T_land_ice(3,1,glr)) .ge.           &                   !y

                    abs(2.0*d_zeta*(H(2,glr)*Geothermal_heat/ice_thermal_cond+      &              !y

                       rho_ice*g*H(2,glr)*H(2,glr)*H(2,glr)/(tau*ice_thermal_cond))))then           !y
                 
                   stage(glr)=accumelation_stage
 
              end if            

          end if

 !       land ice to sea water flux during collapse (m^3/sec)

         if (stage(glr)==accumelation_stage) then  
            land_to_sea_flux(2,:,glr)=0
            else
            land_to_sea_flux(2,:,glr)=area_land_ice(glr)*(H(2,glr)-H(3,glr))/dt_land_ice*(rho_ice/rho_0)
         end if

          ! Advance time step

          T_land_ice(1,:,glr)=T_land_ice(2,:,glr)
          T_land_ice(2,:,glr)=T_land_ice(3,:,glr)
          H(1,glr)=H(2,glr)
          H(2,glr)=H(3,glr)
   
  end do         
    
 !   if  (int(time/tprint)*tprint.eq.time) then    
!            write(33,'(102g12.4)') time/year,H(3,1),(T_land_ice(3,i,1),i=1,NZ,10)
 !   end if
    if  (int(time/tprint)*tprint.eq.time) then

      write(19,'(14g14.6)') time/year,H(3,1),T_land_ice(3,1,1),T_land_ice(3,NZ,1), &
                              land_to_sea_flux(2,2,1),T_atm(3,2)-273.0,T(3,2,2),   &
                              H(3,2), T_land_ice(2,1,2),T_land_ice(2,NZ,2),       &
                              T_atm(3,1)-273.0,T_land_ice(3,NZ,2),T_top(1) 
!     write(29,'(14g14.6)') time/year,H(3,1),H(3,2)  
    
    end if  

    ntime_steps_landice=ntime_steps_landice+1

  end do 
return
end subroutine land_ice




! SIGMA FCN ******* AUG 3 1981 ***************
function sigma(P,T,S)
  ! ******************************************
  ! DERIVED FROM EOS80
  ! REFERENCES
  ! MILLERO ET AL 1980, DEEP-SEA RES.,27A,255-264
  ! JPOTS NINTH REPORT 1978,TENTH REPORT 1980
  ! UNITS:
  !C      PRESSURE        P        DECIBARS
  !       TEMPERATURE     T        DEG CELSIUS (IPTS-68)
  !       SALINITY        S        NSU (IPSS-78)
  !C                      SIGMA    (10.**-3)G/CM**3
  !
  !C UNITS CHANGED TO DECIBARS AND CGS FOR USE AT MIT
  ! N FOFONOFF REVISED OCT 7 1980
  ! *****************************
  IMPLICIT REAL*8 (A-H,O-Z)
  !*Eli: July 21, 1993: changed sigma and P,T,S to REAL*8
  real*8 sigma
  REAL*8 P,T,S

  REAL*8 K,K0,KW
  ! EQUIV
  EQUIVALENCE (E,D,B1,R4),(BW,B,R3),(C,A1,R2)
  EQUIVALENCE (AW,A,R1,R0),(KW,K0,K)
  !C CHANGE PRESSURE FROM INPUT UNITS OF DECIBARS TO BARS
  DP=DBLE(P)
  DT=DBLE(T)
  DS=DBLE(S)
  DP=DP/10.D0
  ! SQUARE ROOT SALINITY.
  SR = DSQRT(DABS(DS))
  ! DENSITY PURE WATER AT ATM PRESS IN KG/M3 = (10**-3)GM/CM3
  R1 = ((((6.536332D-9*DT-1.120083D-6)*DT+1.001685D-4)*DT &
       -9.095290D-3)*DT+6.793952D-2)*DT- .157406D0
  ! SEAWATER DENSITY ATM PRESS.
  R2 = (((5.3875D-9*DT-8.2467D-7)*DT+7.6438D-5)*DT-4.0899D-3)*DT &
       +8.24493D-1
  R3 = (-1.6546D-6*DT+1.0227D-4)*DT-5.72466D-3
  R4 = 4.8314D-4
  !
  SIGMA = SNGL((R4*DS + R3*SR + R2)*DS + R1)
  !C DENSITY - 1000 AT ATMOSPHERIC PRESSURE
  IF(ABS(P).GE..00001)GO TO 1
  !C SIGMA REMAINS UNCHANGED, SINCE IS (10**-3)GM/CM3
  RETURN
  ! COMPUTE COMPRESSION TERMS
1 E = (9.1697D-10*DT+2.0816D-8)*DT-9.9348D-7
  BW = (5.2787D-8*DT-6.12293D-6)*DT+8.50935D-5
  B = BW + E*DS
  !
  D = 1.91075D-4
  C = (-1.6078D-6*DT-1.0981D-5)*DT+2.2838D-3
  AW = ((-5.77905D-7*DT+1.16092D-4)*DT+1.43713D-3)*DT &
       +3.239908D0
  A = (D*SR + C)*DS + AW
  !
  B1 = (-5.3009D-4*DT+1.6483D-2)*DT+7.944D-2
  A1 = ((-6.1670D-5*DT+1.09987D-2)*DT-0.603459D0)*DT+54.6746D0
  KW = (((-5.155288D-5*DT+1.360477D-2)*DT-2.327105D0)*DT &
       +148.4206D0)*DT+19652.21D0
  K0 = (B1*SR + A1)*DS + KW
  ! EVALUATE PRESSURE POLYNOMIAL AND RETURN
  K = (B*DP + A)*DP + K0
  SIGMA = SNGL((K*DBLE(SIGMA) + 1000.D0*DP)/(K-DP))
  !C SIGMA REMAINS UNCHANGED SINCE IS (10**-3)GM/CM**3
  RETURN
END FUNCTION SIGMA
